add http:// to rpm install path
[releng.git] / jjb / apex / apex-deploy.sh
1 #!/bin/bash
2 set -o errexit
3 set -o nounset
4 set -o pipefail
5
6 APEX_PKGS="common undercloud opendaylight-sfc onos"
7 IPV6_FLAG=False
8
9 # log info to console
10 echo "Starting the Apex virtual deployment."
11 echo "--------------------------------------------------------"
12 echo
13
14 if ! rpm -q wget > /dev/null; then
15   sudo yum -y install wget
16 fi
17
18 if [[ $BUILD_DIRECTORY == *verify* ]]; then
19     # Build is from a verify, use local build artifacts (not RPMs)
20     cd $WORKSPACE/../${BUILD_DIRECTORY}
21     WORKSPACE=$(pwd)
22     echo "WORKSPACE modified to $WORKSPACE"
23     cd $WORKSPACE/ci
24 elif [[ ! "$ARTIFACT_NAME" == "latest" ]]; then
25     # if artifact name is passed the pull a
26     # specific artifact from artifacts.opnfv.org
27     # artifact specified should be opnfv-apex-<version>.noarch.rpm
28     RPM_INSTALL_PATH=$GS_URL
29     RPM_LIST=$RPM_INSTALL_PATH/$ARTIFACT_NAME
30 else
31     # Use latest RPMS
32     if [[ $BUILD_DIRECTORY == *apex-build* ]]; then
33       # Triggered from a daily so RPMS should be in local directory
34       BUILD_DIRECTORY=$WORKSPACE/../$BUILD_DIRECTORY
35       echo "BUILD DIRECTORY modified to $BUILD_DIRECTORY"
36
37       if [[ -f ${BUILD_DIRECTORY}/../opnfv.properties ]]; then
38         # if opnfv.properties exists then use the
39         # local build. Source the file so we get local OPNFV vars
40         source ${BUILD_DIRECTORY}/../opnfv.properties
41         RPM_INSTALL_PATH=${BUILD_DIRECTORY}/noarch
42         RPM_LIST=$RPM_INSTALL_PATH/$(basename $OPNFV_RPM_URL)
43       else
44         echo "BUILD_DIRECTORY is from a daily job, so will not use latest from URL"
45         echo "Check that the slave has opnfv.properties in $BUILD_DIRECTORY"
46         exit 1
47       fi
48     else
49       # use the latest from artifacts.opnfv.org
50       # get the latest.properties to get the link to the latest artifact
51       if ! wget -O $WORKSPACE/opnfv.properties http://$GS_URL/latest.properties; then
52         echo "ERROR: Unable to find latest.properties at ${GS_URL}...exiting"
53         exit 1
54       fi
55       # source the file so we get OPNFV vars
56       source opnfv.properties
57       RPM_INSTALL_PATH=$(echo "http://"$OPNFV_RPM_URL | sed 's/\/'"$(basename $OPNFV_RPM_URL)"'//')
58       RPM_LIST=${RPM_INSTALL_PATH}/$(basename $OPNFV_RPM_URL)
59     fi
60 fi
61
62 if [ -z "$DEPLOY_SCENARIO" ]; then
63   echo "Deploy scenario not set!"
64   exit 1
65 fi
66
67 # use local build for verify
68 if [[ "$BUILD_DIRECTORY" == *verify* ]]; then
69     if [ ! -e "${WORKSPACE}/build/lib" ]; then
70       ln -s ${WORKSPACE}/lib ${WORKSPACE}/build/lib
71     fi
72     DEPLOY_SETTINGS_DIR="${WORKSPACE}/config/deploy"
73     NETWORK_SETTINGS_DIR="${WORKSPACE}/config/network"
74     DEPLOY_CMD="$(pwd)/deploy.sh"
75     RESOURCES="${WORKSPACE}/build/images/"
76     CONFIG="${WORKSPACE}/build"
77     LIB="${WORKSPACE}/lib"
78     # Make sure python34 deps are installed
79     for dep_pkg in epel-release python34 python34-PyYAML python34-setuptools; do
80       if ! rpm -q ${dep_pkg} > /dev/null; then
81         if ! sudo yum install -y ${dep_pkg}; then
82           echo "Failed to install ${dep_pkg}"
83           exit 1
84         fi
85       fi
86     done
87
88     # Make sure jinja2 is installed
89     for python_pkg in jinja2; do
90       if ! python3.4 -c "import $python_pkg"; then
91         echo "$python_pkg package not found for python3.4, attempting to install..."
92         if ! sudo easy_install-3.4 $python_pkg; then
93           echo -e "Failed to install $python_pkg package for python3.4"
94           exit 1
95         fi
96       fi
97     done
98
99     # Make sure ipxe-roms-qemu package is updated to latest.
100     # This package is needed for multi virtio nic PXE boot in virtual environment.
101     sudo yum update -y ipxe-roms-qemu
102
103     if [ -z ${PYTHONPATH:-} ]; then
104         export PYTHONPATH=${WORKSPACE}/lib/python
105     else
106         export PYTHONPATH=$PYTHONPATH:${WORKSPACE}/lib/python
107     fi
108 # use RPMs
109 else
110     # find version of RPM
111     VERSION_EXTENSION=$(echo $(basename $RPM_LIST) | grep -Eo '[0-9]+\.[0-9]+-[0-9]{8}')
112     # build RPM List which already includes base Apex RPM
113     for pkg in ${APEX_PKGS}; do
114         RPM_LIST+=" ${RPM_INSTALL_PATH}/opnfv-apex-${pkg}-${VERSION_EXTENSION}.noarch.rpm"
115     done
116
117     # remove old / install new RPMs
118     if rpm -q opnfv-apex > /dev/null; then
119       INSTALLED_RPMS=$(rpm -qa | grep apex)
120       if [ -n "$INSTALLED_RPMS" ]; then
121         sudo yum remove -y ${INSTALLED_RPMS}
122       fi
123     fi
124
125     if ! sudo yum install -y $RPM_LIST; then
126       echo "Unable to install new RPMs: $RPM_LIST"
127       exit 1
128     fi
129
130     DEPLOY_CMD=opnfv-deploy
131     DEPLOY_SETTINGS_DIR="/etc/opnfv-apex/"
132     NETWORK_SETTINGS_DIR="/etc/opnfv-apex/"
133     RESOURCES="/var/opt/opnfv/images"
134     CONFIG="/var/opt/opnfv"
135     LIB="/var/opt/opnfv/lib"
136 fi
137
138 # set env vars to deploy cmd
139 DEPLOY_CMD="CONFIG=${CONFIG} RESOURCES=${RESOURCES} LIB=${LIB} ${DEPLOY_CMD}"
140
141 if [ "$OPNFV_CLEAN" == 'yes' ]; then
142   if sudo test -e '/root/inventory/pod_settings.yaml'; then
143     clean_opts='-i /root/inventory/pod_settings.yaml'
144   else
145     clean_opts=''
146   fi
147   if [[ "$BUILD_DIRECTORY" == *verify* ]]; then
148     sudo CONFIG=${CONFIG} LIB=${LIB} ./clean.sh ${clean_opts}
149   else
150     sudo CONFIG=${CONFIG} LIB=${LIB} opnfv-clean ${clean_opts}
151   fi
152 fi
153
154 if echo ${DEPLOY_SCENARIO} | grep ipv6; then
155   IPV6_FLAG=True
156   DEPLOY_SCENARIO=$(echo ${DEPLOY_SCENARIO} |  sed 's/-ipv6//')
157   echo "INFO: IPV6 Enabled"
158 fi
159
160 echo "Deploy Scenario set to ${DEPLOY_SCENARIO}"
161 DEPLOY_FILE="${DEPLOY_SETTINGS_DIR}/${DEPLOY_SCENARIO}.yaml"
162
163 if [ ! -e "$DEPLOY_FILE" ]; then
164   echo "ERROR: Required settings file missing: Deploy settings file ${DEPLOY_FILE}"
165 fi
166
167 if [[ "$JOB_NAME" == *virtual* ]]; then
168   # settings for virtual deployment
169   if [ "$IPV6_FLAG" == "True" ]; then
170     NETWORK_FILE="${NETWORK_SETTINGS_DIR}/network_settings_v6.yaml"
171   else
172     NETWORK_FILE="${NETWORK_SETTINGS_DIR}/network_settings.yaml"
173   fi
174   DEPLOY_CMD="${DEPLOY_CMD} -v"
175 else
176   # settings for bare metal deployment
177   if [ "$IPV6_FLAG" == "True" ]; then
178     NETWORK_FILE="/root/network/network_settings_v6.yaml"
179   else
180     NETWORK_FILE="/root/network/network_settings.yaml"
181   fi
182   INVENTORY_FILE="/root/inventory/pod_settings.yaml"
183
184   if ! sudo test -e "$INVENTORY_FILE"; then
185     echo "ERROR: Required settings file missing: Inventory settings file ${INVENTORY_FILE}"
186     exit 1
187   fi
188   # include inventory file for bare metal deployment
189   DEPLOY_CMD="${DEPLOY_CMD} -i ${INVENTORY_FILE}"
190 fi
191
192 # Check that network settings file exists
193 if ! sudo test -e "$NETWORK_FILE"; then
194   echo "ERROR: Required settings file missing: Network Settings file ${NETWORK_FILE}"
195   exit 1
196 fi
197
198 # start deployment
199 sudo ${DEPLOY_CMD} -d ${DEPLOY_FILE} -n ${NETWORK_FILE} --debug
200
201 echo
202 echo "--------------------------------------------------------"
203 echo "Done!"